Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/XMP.pm	(revision 34921)
@@ -2780,38 +3427,162 @@
     # keep track of current nodeID at this nesting level
     my $oldNodeID = $$blankInfo{NodeID};
-
     pos($$dataPt) = $start;
+
+    # lookup for translating namespace prefixes
+    my $xlatNS = $$et{xlatNS};
+
     Element: for (;;) {
+        # all done if there isn't enough data for another element
+        # (the smallest possible element is 4 bytes, eg. "<a/>")
+        last if pos($$dataPt) > $end - 4;
         # reset nodeID before processing each element
         my $nodeID = $$blankInfo{NodeID} = $oldNodeID;
         # get next element
-        last unless $$dataPt =~ m/<([-\w:.\x80-\xff]+)(.*?)>/sg;
-        my ($prop, $attrs) = ($1, $2);
-        my $val = '';
+        last if $$dataPt !~ m{<([?/]?)([-\w:.\x80-\xff]+|!--)([^>]*)>}sg or pos($$dataPt) > $end;
+        # (the only reason we match '<[?/]' is to keep from scanning past the
+        #  "<?xpacket end..." terminator or other closing token, so
+        next if $1;
+        my ($prop, $attrs) = ($2, $3);
+        # skip comments
+        if ($prop eq '!--') {
+            next if $attrs =~ /--$/ or $$dataPt =~ /-->/sg;
+            last;
+        }
+        my $valStart = pos($$dataPt);
+        my $valEnd;
         # only look for closing token if this is not an empty element
-        # (empty elements end with '/', ie. <a:b/>)
+        # (empty elements end with '/', eg. <a:b/>)
         if ($attrs !~ s/\/$//) {
             my $nesting = 1;
             for (;;) {
 # this match fails with perl 5.6.2 (perl bug!), but it works without
-# the '(.*?)', so do it the hard way instead...
+# the '(.*?)', so we must do it differently...
 #                $$dataPt =~ m/(.*?)<\/$prop>/sg or last Element;
 #                my $val2 = $1;
-                my $pos = pos($$dataPt);
-                unless ($$dataPt =~ m/<\/$prop>/sg) {
-                    $exifTool->Warn("XMP format error (no closing tag for $prop)");
+                # find next matching closing token, or the next opening token
+                # of a nested same-named element
+                if ($$dataPt !~ m{<(/?)$prop([-\w:.\x80-\xff]*)(.*?(/?))>}sg or
+                    pos($$dataPt) > $end)
+                {
+                    $et->Warn("XMP format error (no closing tag for $prop)");
                     last Element;
                 }
-                my $len = pos($$dataPt) - $pos - length($prop) - 3;
-                my $val2 = substr($$dataPt, $pos, $len);
-                # increment nesting level for each contained similar opening token
-                ++$nesting while $val2 =~ m/<$prop\b.*?(\/?)>/sg and $1 ne '/';
-                $val .= $val2;
-                --$nesting or last;
-                $val .= "</$prop>";
-            }
-        }
-        my $parseResource;
+                next if $2; # ignore opening properties with different names
+                if ($1) {
+                    next if --$nesting;
+                    $valEnd = pos($$dataPt) - length($prop) - length($3) - 3;
+                    last;   # this element is complete
+                }
+                # this is a nested opening token (or empty element)
+                ++$nesting unless $4;
+            }
+        } else {
+            $valEnd = $valStart;
+        }
+        $start = pos($$dataPt);         # start from here the next time around
+
+        # extract property attributes
+        my ($parseResource, %attrs, @attrs);
+        while ($attrs =~ m/(\S+?)\s*=\s*(['"])(.*?)\2/sg) {
+            my ($attr, $val) = ($1, $3);
+            # handle namespace prefixes (defined by xmlns:PREFIX, or used with PREFIX:tag)
+            if ($attr =~ /(.*?):/) {
+                if ($1 eq 'xmlns') {
+                    my $ns = substr($attr, 6);
+                    my $stdNS = $uri2ns{$val};
+                    # keep track of namespace prefixes defined in this scope (for Validate)
+                    $$et{definedNS}{$ns} = $definedNS{$ns} = 1 unless $$et{definedNS}{$ns};
+                    unless ($stdNS) {
+                        my $try = $val;
+                        # patch for Nikon NX2 URI bug for Microsoft PhotoInfo namespace
+                        $try =~ s{/$}{} or $try .= '/';
+                        $stdNS = $uri2ns{$try};
+                        if ($stdNS) {
+                            $val = $try;
+                            $et->WarnOnce("Fixed incorrect URI for xmlns:$ns", 1);
+                        } else {
+                            # look for same namespace with different version number
+                            $try = quotemeta $val; # (note: escapes slashes too)
+                            $try =~ s{\\/\d+\\\.\d+(\\/|$)}{\\/\\d+\\\.\\d+$1};
+                            my ($good) = grep /^$try$/, keys %uri2ns;
+                            if ($good) {
+                                $stdNS = $uri2ns{$good};
+                                $et->VPrint(0, $$et{INDENT}, "[different $stdNS version: $val]\n");
+                            }
+                        }
+                    }
+                    # tame wild namespace prefixes (patches Microsoft stupidity)
+                    my $newNS;
+                    if ($stdNS) {
+                        # use standard namespace prefix if pre-defined
+                        if ($stdNS ne $ns) {
+                            $newNS = $stdNS;
+                        } elsif ($$xlatNS{$ns}) {
+                            # this prefix is re-defined to the standard prefix in this scope
+                            $newNS = '';
+                        }
+                    } elsif ($$et{curNS}{$val}) {
+                        # use a consistent prefix over the entire XMP for a given namespace URI
+                        $newNS = $$et{curNS}{$val} if $$et{curNS}{$val} ne $ns;
+                    } else {
+                        my $curURI = $$et{curURI};
+                        my $curNS = $$et{curNS};
+                        my $usedNS = $ns;
+                        # use unique prefixes for all namespaces across the entire XMP
+                        if ($$curURI{$ns} or $nsURI{$ns}) {
+                            # generate a temporary namespace prefix to resolve any conflict
+                            my $i = 0;
+                            ++$i while $$curURI{"tmp$i"};
+                            $newNS = $usedNS = "tmp$i";
+                        }
+                        # keep track of the namespace prefixes and URI's used in this XMP
+                        $$curNS{$val} = $usedNS;
+                        $$curURI{$usedNS} = $val;
+                    }
+                    if (defined $newNS) {
+                        # save translation used in containing scope if necessary
+                        # create new namespace translation for the scope of this element
+                        $saveNS or $saveNS = $xlatNS, $xlatNS = $$et{xlatNS} = { %$xlatNS };
+                        if (length $newNS) {
+                            # use the new namespace prefix
+                            $$xlatNS{$ns} = $newNS;
+                            $attr = 'xmlns:' . $newNS;
+                            # must go through previous attributes and change prefixes if necessary
+                            foreach (@attrs) {
+                                next unless /(.*?):/ and $1 eq $ns and $1 ne $newNS;
+                                my $newAttr = $newNS . substr($_, length($ns));
+                                $attrs{$newAttr} = $attrs{$_};
+                                delete $attrs{$_};
+                                $_ = $newAttr;
+                            }
+                        } else {
+                            delete $$xlatNS{$ns};
+                        }
+                    }
+                } else {
+                    $attr = $$xlatNS{$1} . substr($attr, length($1)) if $$xlatNS{$1};
+                    $usedNS{$1} = 1;
+                }
+            }
+            push @attrs, $attr;    # preserve order
+            $attrs{$attr} = $val;
+        }
+        if ($prop =~ /(.*?):/) {
+            $usedNS{$1} = 1;
+            # tame wild namespace prefixes (patch for Microsoft stupidity)
+            $prop = $$xlatNS{$1} . substr($prop, length($1)) if $$xlatNS{$1};
+        }
+
         if ($prop eq 'rdf:li') {
+            # impose a reasonable maximum on the number of items in a list
+            if ($nItems == 1000) {
+                my ($tg,$ns) = GetXMPTagID($propList);
+                if ($isWriting) {
+                    $et->Warn("Excessive number of items for $ns:$tg. Processing may be slow", 1);
+                } elsif (not $$et{OPTIONS}{IgnoreMinorErrors}) {
+                    $et->Warn("Extracted only 1000 $ns:$tg items. Ignore minor errors to extract all", 2);
+                    last;
+                }
+            }
             # add index to list items so we can keep them in order
             # (this also enables us to keep structure elements grouped properly
@@ -2823,27 +3594,30 @@
             # 10,11,12-19,210,211-299,3100,3101-3999,41000...9999999999.
             $prop .= ' ' . length($nItems) . $nItems;
+            # reset LIST_TAGS at the start of the outtermost list
+            # (avoids accumulating incorrectly-written elements in a correctly-written list)
+            if (not $nItems and not grep /^rdf:li /, @$propList) {
+                $$et{LIST_TAGS} = { };
+            }
             ++$nItems;
         } elsif ($prop eq 'rdf:Description') {
-            # trim comments and whitespace from rdf:Description properties only
-            $val =~ s/<!--.*?-->//g;
-            $val =~ s/^\s*(.*)\s*$/$1/;
             # remove unnecessary rdf:Description elements since parseType='Resource'
             # is more efficient (also necessary to make property path consistent)
-            $parseResource = 1 if grep /^rdf:Description$/, @$propListPt;
+            $parseResource = 1 if grep /^rdf:Description$/, @$propList;
         } elsif ($prop eq 'xmp:xmpmeta') {
             # patch MicrosoftPhoto unconformity
             $prop = 'x:xmpmeta';
-        }
-
-        # extract property attributes
-        my (%attrs, @attrs);
-        while ($attrs =~ m/(\S+?)\s*=\s*(['"])(.*?)\2/sg) {
-            push @attrs, $1;    # preserve order
-            $attrs{$1} = $3;
+            $et->Warn('Wrong namespace for xmpmeta') if $$et{XmpValidate};
         }
 
         # hook for special parsing of attributes
-        $attrProc and &$attrProc(\@attrs, \%attrs, \$prop, \$val);
-            
+        my $val;
+        if ($attrProc) {
+            $val = substr($$dataPt, $valStart, $valEnd - $valStart);
+            if (&$attrProc(\@attrs, \%attrs, \$prop, \$val)) {
+                # the value was changed, so reset $valStart/$valEnd to use $val instead
+                $valStart = $valEnd;
+            }
+        }
+
         # add nodeID to property path (with leading ' #') if it exists
         if (defined $attrs{'rdf:nodeID'}) {
@@ -2855,11 +3629,11 @@
 
         # push this property name onto our hierarchy list
-        push @$propListPt, $prop unless $parseResource;
+        push @$propList, $prop unless $parseResource;
 
         if ($isSVG) {
             # ignore everything but top level SVG tags and metadata unless Unknown set
-            unless ($exifTool->{OPTIONS}{Unknown} > 1 or $exifTool->{OPTIONS}{Verbose}) {
-                if (@$propListPt > 1 and $$propListPt[1] !~ /\b(metadata|desc|title)$/) {
-                    pop @$propListPt;
+            unless ($$et{OPTIONS}{Unknown} > 1 or $$et{OPTIONS}{Verbose}) {
+                if (@$propList > 1 and $$propList[1] !~ /\b(metadata|desc|title)$/) {
+                    pop @$propList;
                     next;
                 }
@@ -2867,5 +3641,10 @@
             if ($prop eq 'svg' or $prop eq 'metadata') {
                 # add svg namespace prefix if missing to ignore these entries in the tag name
-                $$propListPt[-1] = "svg:$prop";
+                $$propList[-1] = "svg:$prop";
+            }
+        } elsif ($$et{XmpIgnoreProps}) { # ignore specified properties for tag name
+            foreach (@{$$et{XmpIgnoreProps}}) {
+                last unless @$propList;
+                pop @$propList if $_ eq $$propList[0];
             }
         }
@@ -2875,4 +3654,5 @@
         my ($shortName, $shorthand, $ignored);
         foreach $shortName (@attrs) {
+            next unless defined $attrs{$shortName};
             my $propName = $shortName;
             my ($ns, $name);
@@ -2891,18 +3671,17 @@
                 $name = $propName;
             }
-            # keep track of the namespace prefixes used
-            if ($ns eq 'xmlns') {
-                unless ($attrs{$shortName}) {
-                    $exifTool->WarnOnce("Duplicate namespace '$shortName'");
-                    next;
-                }
-                $curNS{$name} = $attrs{$shortName};
-                my $stdNS = $uri2ns{$attrs{$shortName}};
-                # translate namespace if non-standard (except 'x' and 'iX')
-                if ($stdNS and $name ne $stdNS and $stdNS ne 'x' and $stdNS ne 'iX') {
-                    # make a copy of the standard translations so we can modify it
-                    $xlatNamespace = { %stdXlatNS } if $xlatNamespace eq \%stdXlatNS;
-                    # translate this namespace prefix to the standard version
-                    $$xlatNamespace{$name} = $stdXlatNS{$stdNS} || $stdNS;
+            if ($propName eq 'rdf:about') {
+                if (not $$et{XmpAbout}) {
+                    $$et{XmpAbout} = $attrs{$shortName};
+                } elsif ($$et{XmpAbout} ne $attrs{$shortName}) {
+                    if ($isWriting) {
+                        my $str = "Different 'rdf:about' attributes not handled";
+                        unless ($$et{WARNED_ONCE}{$str}) {
+                            $et->Error($str, 1);
+                            $$et{WARNED_ONCE}{$str} = 1;
+                        }
+                    } elsif ($$et{XmpValidate}) {
+                        $et->WarnOnce("Different 'rdf:about' attributes");
+                    }
                 }
             }
@@ -2912,5 +3691,5 @@
                     my $stdNS = $uri2ns{$attrs{$shortName}};
                     unless ($stdNS and ($stdNS eq 'x' or $stdNS eq 'iX')) {
-                        my $nsUsed = $exifTool->{XMP_NS};
+                        my $nsUsed = $$et{XMP_NS};
                         $$nsUsed{$name} = $attrs{$shortName} unless defined $$nsUsed{$name};
                     }
@@ -2918,24 +3697,16 @@
                     next;
                 } elsif ($recognizedAttrs{$propName}) {
-                    # save UUID to use same ID when writing
-                    if ($propName eq 'rdf:about') {
-                        if (not $exifTool->{XMP_ABOUT}) {
-                            $exifTool->{XMP_ABOUT} = $attrs{$shortName};
-                        } elsif ($exifTool->{XMP_ABOUT} ne $attrs{$shortName}) {
-                            $exifTool->Error("Different 'rdf:about' attributes not handled", 1);
-                        }
-                    }
                     next;
                 }
             }
             my $shortVal = $attrs{$shortName};
-            if ($ignoreNamespace{$ns}) {
+            if ($ignoreNamespace{$ns} or $ignoreProp{$prop}) {
                 $ignored = $propName;
                 # handle special attributes (extract as tags only once if not empty)
                 if (ref $recognizedAttrs{$propName} and $shortVal) {
                     my ($tbl, $id, $name) = @{$recognizedAttrs{$propName}};
-                    my $val = UnescapeXML($shortVal);
-                    unless (defined $$exifTool{VALUE}{$name} and $$exifTool{VALUE}{$name} eq $val) {
-                        $exifTool->HandleTag(GetTagTable($tbl), $id, $val);
+                    my $tval = UnescapeXML($shortVal);
+                    unless (defined $$et{VALUE}{$name} and $$et{VALUE}{$name} eq $tval) {
+                        $et->HandleTag(GetTagTable($tbl), $id, $tval);
                     }
                 }
@@ -2943,61 +3714,99 @@
             }
             delete $attrs{$shortName};  # don't re-use this attribute
-            push @$propListPt, $propName;
+            push @$propList, $propName;
             # save this shorthand XMP property
             if (defined $nodeID) {
-                SaveBlankInfo($blankInfo, $propListPt, $shortVal);
+                SaveBlankInfo($blankInfo, $propList, $shortVal);
             } elsif ($isWriting) {
-                CaptureXMP($exifTool, $propListPt, $shortVal);
+                CaptureXMP($et, $propList, $shortVal);
             } else {
-                &$foundProc($exifTool, $tagTablePtr, $propListPt, $shortVal);
-            }
-            pop @$propListPt;
+                ValidateProperty($et, $propList) if $$et{XmpValidate};
+                &$foundProc($et, $tagTablePtr, $propList, $shortVal);
+            }
+            pop @$propList;
             $shorthand = 1;
         }
         if ($isWriting) {
-            if (ParseXMPElement($exifTool, $tagTablePtr, \$val, 0, $propListPt, $blankInfo)) {
-                # undefine value since we found more properties within this one
-                undef $val;
+            if (ParseXMPElement($et, $tagTablePtr, $dataPt, $valStart, $valEnd,
+                                $propList, $blankInfo))
+            {
+                # (no value since we found more properties within this one)
                 # set an error on any ignored attributes here, because they will be lost
-                $exifTool->{XMP_ERROR} = "Can't handle XMP attribute '$ignored'" if $ignored;
-            }
-            if (defined $val and (length $val or not $shorthand)) {
+                $$et{XMP_ERROR} = "Can't handle XMP attribute '${ignored}'" if $ignored;
+            } elsif (not $shorthand or $valEnd != $valStart) {
+                $val = substr($$dataPt, $valStart, $valEnd - $valStart);
+                # remove comments and whitespace from rdf:Description only
+                if ($prop eq 'rdf:Description') {
+                    $val =~ s/<!--.*?-->//g; $val =~ s/^\s+//; $val =~ s/\s+$//;
+                }
                 if (defined $nodeID) {
-                    SaveBlankInfo($blankInfo, $propListPt, $val, \%attrs);
+                    SaveBlankInfo($blankInfo, $propList, $val, \%attrs);
                 } else {
-                    CaptureXMP($exifTool, $propListPt, $val, \%attrs);
+                    CaptureXMP($et, $propList, $val, \%attrs);
                 }
             }
         } else {
-            # if element value is empty, take value from 'resource' attribute
-            # (preferentially) or 'about' attribute (if no 'resource')
-            my $wasEmpty;
-            if ($val eq '' and ($attrs =~ /\bresource=(['"])(.*?)\1/ or
-                                $attrs =~ /\babout=(['"])(.*?)\1/))
+            # look for additional elements contained within this one
+            if ($valStart == $valEnd or
+                !ParseXMPElement($et, $tagTablePtr, $dataPt, $valStart, $valEnd,
+                                 $propList, $blankInfo))
             {
-                $val = $2;
-                $wasEmpty = 1;
-            }
-            # look for additional elements contained within this one
-            if (!ParseXMPElement($exifTool, $tagTablePtr, \$val, 0, $propListPt, $blankInfo)) {
+                my $wasEmpty;
+                unless (defined $val) {
+                    $val = substr($$dataPt, $valStart, $valEnd - $valStart);
+                    # remove comments and whitespace from rdf:Description only
+                    if ($prop eq 'rdf:Description' and $val) {
+                        $val =~ s/<!--.*?-->//g; $val =~ s/^\s+//; $val =~ s/\s+$//;
+                    }
+                    # if element value is empty, take value from RDF 'value' or 'resource' attribute
+                    # (preferentially) or 'about' attribute (if no 'value' or 'resource')
+                    if ($val eq '' and ($attrs =~ /\brdf:(?:value|resource)=(['"])(.*?)\1/ or
+                                        $attrs =~ /\brdf:about=(['"])(.*?)\1/))
+                    {
+                        $val = $2;
+                        $wasEmpty = 1;
+                    }
+                }
                 # there are no contained elements, so this must be a simple property value
                 # (unless we already extracted shorthand values from this element)
                 if (length $val or not $shorthand) {
-                    my $lastProp = $$propListPt[-1];
+                    my $lastProp = $$propList[-1];
                     if (defined $nodeID) {
-                        SaveBlankInfo($blankInfo, $propListPt, $val);
+                        SaveBlankInfo($blankInfo, $propList, $val);
                     } elsif ($lastProp eq 'rdf:type' and $wasEmpty) {
                         # do not extract empty structure types (for now)
                     } elsif ($lastProp =~ /^et:(desc|prt|val)$/ and ($count or $1 eq 'desc')) {
-                        # ignore et:desc, and et:val if preceeded by et:prt
+                        # ignore et:desc, and et:val if preceded by et:prt
                         --$count;
                     } else {
-                        &$foundProc($exifTool, $tagTablePtr, $propListPt, $val, \%attrs);
+                        ValidateProperty($et, $propList, \%attrs) if $$et{XmpValidate};
+                        &$foundProc($et, $tagTablePtr, $propList, $val, \%attrs);
                     }
                 }
             }
         }
-        pop @$propListPt unless $parseResource;
+        pop @$propList unless $parseResource;
         ++$count;
+
+        # validate namespace prefixes used at this level if necessary
+        if ($$et{XmpValidate}) {
+            foreach (sort keys %usedNS) {
+                next if $$et{definedNS}{$_} or $_ eq 'xml';
+                if (defined $$et{definedNS}{$_}) {
+                    $et->Warn("XMP namespace $_ is used out of scope");
+                } else {
+                    $et->Warn("Undefined XMP namespace: $_");
+                }
+                $$et{definedNS}{$_} = -1;  # (don't warn again for this namespace)
+            }
+            # reset namespaces that went out of scope
+            $$et{definedNS}{$_} = 0 foreach keys %definedNS;
+            undef %usedNS;
+            undef %definedNS;
+        }
+
+        last if $start >= $end;
+        pos($$dataPt) = $start;
+        $$dataPt =~ /\G\s+/gc;  # skip white space after closing token
     }
 #
@@ -3005,7 +3814,10 @@
 #
     if ($processBlankInfo and %{$$blankInfo{Prop}}) {
-        ProcessBlankInfo($exifTool, $tagTablePtr, $blankInfo, $isWriting);
+        ProcessBlankInfo($et, $tagTablePtr, $blankInfo, $isWriting);
         %$blankInfo = ();   # free some memory
     }
+    # restore namespace lookup from the containing scope
+    $$et{xlatNS} = $saveNS if $saveNS;
+
     return $count;  # return the number of elements found at this level
 }
@@ -3027,20 +3839,41 @@
 sub ProcessXMP($$;$)
 {
-    my ($exifTool, $dirInfo, $tagTablePtr) = @_;
+    my ($et, $dirInfo, $tagTablePtr) = @_;
     my $dataPt = $$dirInfo{DataPt};
-    my ($dirStart, $dirLen, $dataLen);
+    my ($dirStart, $dirLen, $dataLen, $double);
     my ($buff, $fmt, $hasXMP, $isXML, $isRDF, $isSVG);
     my $rtnVal = 0;
     my $bom = 0;
-    undef %curNS;
+
+    # namespaces and prefixes currently in effect while parsing the file,
+    # and lookup to translate brain-dead-Microsoft-Photo-software prefixes
+    $$et{curURI} = { };
+    $$et{curNS}  = { };
+    $$et{xlatNS} = { };
+    $$et{definedNS} = { };
+    delete $$et{XmpAbout};
+    delete $$et{XmpValidate};   # don't validate by default
+    delete $$et{XmpValidateLangAlt};
 
     # ignore non-standard XMP while in strict MWG compatibility mode
-    if ($Image::ExifTool::MWG::strict and not $$exifTool{XMP_CAPTURE} and
-        $$exifTool{FILE_TYPE} =~ /^(JPEG|TIFF|PSD)$/)
+    if (($Image::ExifTool::MWG::strict or $$et{OPTIONS}{Validate}) and
+        not ($$et{XMP_CAPTURE} or $$et{DOC_NUM}) and
+        (($$dirInfo{DirName} || '') eq 'XMP' or $$et{FILE_TYPE} eq 'XMP'))
     {
-        my $path = $exifTool->MetadataPath();
-        unless ($path =~ /^(JPEG-APP1-XMP|TIFF-IFD0-XMP|PSD-XMP)$/) {
-            $exifTool->Warn("Ignored non-standard XMP at $path");
+        $$et{XmpValidate} = { } if $$et{OPTIONS}{Validate};
+        my $path = $et->MetadataPath();
+        my $nonStd;
+        if ($$et{FILE_TYPE} =~ /^(JPEG|TIFF|PSD)$/ and $path !~ /^(JPEG-APP1-XMP|TIFF-IFD0-XMP|PSD-XMP)$/) {
+            $nonStd = 1;
+        }
+        if ($nonStd and $Image::ExifTool::MWG::strict) {
+            $et->Warn("Ignored non-standard XMP at $path");
             return 1;
+        }
+        if ($nonStd) {
+            $et->Warn("Non-standard XMP at $path", 1);
+        } elsif (not $$dirInfo{IsExtended}) {
+            $et->Warn("Duplicate XMP at $path") if $$et{DIR_COUNT}{XMP};
+            $$et{DIR_COUNT}{XMP} = ($$et{DIR_COUNT}{XMP} || 0) + 1; # count standard XMP
         }
     }
@@ -3049,12 +3882,14 @@
         $dirLen = $$dirInfo{DirLen} || (length($$dataPt) - $dirStart);
         $dataLen = $$dirInfo{DataLen} || length($$dataPt);
+        # check leading BOM (may indicate double-encoded UTF)
+        pos($$dataPt) = $dirStart;
+        $double = $1 if $$dataPt =~ /\G((\0\0)?\xfe\xff|\xff\xfe(\0\0)?|\xef\xbb\xbf)\0*<\0*\?\0*x\0*p\0*a\0*c\0*k\0*e\0*t/g;
     } else {
-        my $type;
+        my ($type, $mime, $buf2, $buf3);
         # read information from XMP file
         my $raf = $$dirInfo{RAF} or return 0;
         $raf->Read($buff, 256) or return 0;
-        my ($buf2, $buf3, $double);
         ($buf2 = $buff) =~ tr/\0//d;    # cheap conversion to UTF-8
-        # remove leading comments if they exist (ie. ImageIngester)
+        # remove leading comments if they exist (eg. ImageIngester)
         while ($buf2 =~ /^\s*<!--/) {
             # remove the comment if it is complete
@@ -3081,5 +3916,5 @@
             } elsif ($buf2 =~ /^(\xff\xfe)(<\?xml|<rdf:RDF|<x(mp)?:x[ma]pmeta)/g) {
                 $fmt = 'v';     # UTF-16 or 32 II with BOM
-            } elsif ($buf2 =~ /^(\xef\xbb\xbf)?(<\?xml|<rdf:RDF|<x(mp)?:x[ma]pmeta)/g) {
+            } elsif ($buf2 =~ /^(\xef\xbb\xbf)?(<\?xml|<rdf:RDF|<x(mp)?:x[ma]pmeta|<svg\b)/g) {
                 $fmt = 0;       # UTF-8 with BOM or unknown encoding without BOM
             } elsif ($buf2 =~ /^(\xfe\xff|\xff\xfe|\xef\xbb\xbf)(<\?xpacket begin=)/g) {
@@ -3090,8 +3925,16 @@
             $bom = 1 if $1;
             if ($2 eq '<?xml') {
-                if ($buf2 =~ /<x(mp)?:x[ma]pmeta/) {
+                if (defined $fmt and not $fmt and $buf2 =~ /^[^\n\r]*[\n\r]+<\?aid /s) {
+                    undef $$et{XmpValidate};    # don't validate INX
+                    if ($$et{XMP_CAPTURE}) {
+                        $et->Error("ExifTool does not yet support writing of INX files");
+                        return 0;
+                    }
+                    $type = 'INX';
+                } elsif ($buf2 =~ /<x(mp)?:x[ma]pmeta/) {
                     $hasXMP = 1;
                 } else {
-                    # identify SVG images by DOCTYPE if available
+                    undef $$et{XmpValidate};    # don't validate XML
+                    # identify SVG images and PLIST files by DOCTYPE if available
                     if ($buf2 =~ /<!DOCTYPE\s+(\w+)/) {
                         if ($1 eq 'svg') {
@@ -3099,4 +3942,7 @@
                         } elsif ($1 eq 'plist') {
                             $type = 'PLIST';
+                        } elsif ($1 eq 'REDXIF') {
+                            $type = 'RMD';
+                            $mime = 'application/xml';
                         } else {
                             return 0;
@@ -3106,7 +3952,9 @@
                     } elsif ($buf2 =~ /<rdf:RDF/) {
                         $isRDF = 1;
+                    } elsif ($buf2 =~ /<plist[\s>]/) {
+                        $type = 'PLIST';
                     }
-                    if ($isSVG and $exifTool->{XMP_CAPTURE}) {
-                        $exifTool->Error("ExifTool does not yet support writing of SVG images");
+                    if ($isSVG and $$et{XMP_CAPTURE}) {
+                        $et->Error("ExifTool does not yet support writing of SVG images");
                         return 0;
                     }
